#! /bin/sh

# =============================================================================
# For User Setting
# =============================================================================
#
mif="SETTHIS!"          # Specify NIC name for ADSL modem connection
#mip="192.168.0.254"    # IP address for NTT ADSL modem NM, MN II
#mnet="192.168.0.0"     # Network Address for NTT ADSL modem NM, MN II
mip="192.168.116.254"   # IP address for NTT ADSL modem NM III
mnet="192.168.116.0"    # Network Address for NTT ADSL modem NM III
mmask="255.255.255.0"   # Subnet mask for NTT ADSL modem NM I,II,III


# =============================================================================
# You do not need to modify the following section
# =============================================================================
#
. /usr/local/richscripts/etc/common.lib

natd="8669"

CMD_KILL="/bin/kill"
CMD_NATD="/sbin/natd"
CMD_ROUTE="/sbin/route"

case $1 in
  start)
    $CMD_IFCONFIG $mif inet $mip netmask $mmask
    $CMD_ROUTE add -net $mnet -netmask $mmask -interface $mif
    ps=`$CMD_PS ax | $CMD_GREP natd | $CMD_GREP $mif`
    for pid in $ps; do
      break
    done
    if [ -z "$pid" ]; then
      $CMD_NATD -dynamic -port $natd -same_ports -n $mif
    fi
    $CMD_IPFW add 65500 divert $natd ip from $mnet:$mmask to $mip in via $mif
    $CMD_IPFW add 65501 allow ip from $mnet:$mmask to $inet:$imask in via $mif
    $CMD_IPFW add 65502 allow ip from $mnet:$mmask to $mip in via $mif
    $CMD_IPFW add 65503 divert $natd ip from $inet:$imask to $mnet:$mmask out via $mif
    $CMD_IPFW add 65440 allow ip from $mip to $mnet:$mmask out via $mif
    ;;
  stop)
    ps=`$CMD_PS ax | $CMD_GREP natd | $CMD_GREP $mif`
    for pid in $ps; do
      break
    done
    $CMD_IFCONFIG $mif inet 0.0.0.0 netmask 255.0.0.0
    $CMD_ROUTE delete -net $mnet
    $CMD_KILL -9 $pid
    $CMD_IPFW delete 65500
    $CMD_IPFW delete 65501
    $CMD_IPFW delete 65502
    $CMD_IPFW delete 65503
    $CMD_IPFW delete 65504
    ;;
esac
